// Copyright (c) 2013 Jasper den Ouden, under the MIT license, 
// see ../doc/mit.txt from the project directory.

#version 3.7; //.0.RC4-2(pacman)

#include "colors.inc"
#include "functions.inc"

global_settings
{ assumed_gamma 1.0
  radiosity {
    pretrace_start 0.08
    pretrace_end   0.01
    count 150
    nearest_count 10
    error_bound 0.5
    recursion_limit 1
    low_error_factor 0.5
    gray_threshold 0.0
    minimum_reuse 0.005
    maximum_reuse 0.2
    brightness 1
    adc_bailout 0.005
  } 
}

camera{
  location <17,0,0>
  look_at 0
  angle 10
}
light_source{ <500, 500, -800> White }

#declare BASE_SHAPE=
function
{
  sqrt(x*x+y*y+z*z) - 1
}

#declare CRATER_SHAPE_TEMPLT=
function
{
  pigment
  {
    crackle form <1.5,0,0>
    color_map
    {
      [0 rgb    <1.0,1.0,1.0>]
      [0.75 rgb <0.0,0.0,0.0>]
      [1 rgb    <0.2,0.2,0.2>]
    }
    cubic_wave
  }
}

#declare smoothe_crater = function(p,xo)
{ min(p*p/(xo*(2-xo)), (2*(p-xo)+xo)/(2-xo)) }

#declare CRATER_SHAPE=
function(x,y,z,S)
{
  smoothe_crater(CRATER_SHAPE_TEMPLT(x/S,y/S,z/S).red, 0.1) * 
  (1 - 0.04*sqrt(f_noise3d(50*(x+RANDOM_1),50*(y+RANDOM_2),50*(z+RANDOM_3)))/
            (0.04+pow(CRATER_SHAPE_TEMPLT(x/S,y/S,z/S).red,2)))
}

isosurface
{
  function
    {
      BASE_SHAPE(x,y,z) - RADIUS
      + 0.5 * f_noise3d(x/10+RANDOM_4,y/10+RANDOM_5,z/10+RANDOM_6)
      + 0.2 * f_noise3d(x+RANDOM_7,y+RANDOM_8,z+RANDOM_9)
      + 0.2 * f_noise3d(x+RANDOM_10,y+RANDOM_11,z+RANDOM_12)
      + 0.2 * pow(f_noise3d(2*x,2*y,2*z),2)
      + 0.01* f_noise3d(20*(x+RANDOM_13),20*(y+RANDOM_14),20*(z+RANDOM_15))
      + .04 * CRATER_SHAPE(x+RANDOM_16,y+RANDOM_17,z+RANDOM_18,.35) *
        (1 + f_noise3d(x+RANDOM_19,y+RANDOM_20,z+RANDOM_21))
      + .01 * CRATER_SHAPE(x+RANDOM_22,y+RANDOM_23,z+RANDOM_24,.1)
    }
  contained_by{box{-1.2 1.2}}
  threshold 0

  max_gradient 2.0

  texture
  {
    pigment
    {
      bozo
      color_map
      {
        [0 rgb <0.3,0.3,0.3>]
        [1 rgb <1.0,1.0,1.0>]
      }
      scale 0.2
    }
    finish
    {
      ambient 0.0
      diffuse 1.0
      brilliance 1.0
      specular 0.1
      roughness 0.08
    }
  }
  normal
  {
    agate 0.13
    scale 0.08
  }
}