#!/bin/bash
# Under public domain or mit license, whichever you choose. See doc/mit.txt

# * Calculates default parameters.
# * Makes randoms
# * Transforms templates.
#Use pov.sh to actually draw it.

#Works on directory given, defaultly the parent one.

AT_DIR=$1
if [ "$AT_DIR" == "" ]; then
    AT_DIR=".."
fi

#Generates the local povray files.

#Stuff parameters.
echo Getting given parameters and generating randoms.
cat params > full.params

echo Figuring default values
for el in `cat $AT_DIR/defaults/order`; do
    if [ "`grep $el' ' full.params`" == "" ]; then #Dont have a value, 
        $AT_DIR/defaults/$el full.params >> full.params #Try generate one.
    fi
done

info() #Gets some parameters we need besides the `replace`
{   grep "$1 " full.params |awk '{print($2)}' 
}
RANDOM_CNT=`info RANDOM_CNT`
if [ "$RANDOM_CNT"=="" ]; then
    RANDOM_CNT=32 #Arbitrary.
fi
#Need random parameters.
echo `for el in  $(seq 1 $RANDOM_CNT); do
    echo RANDOM_$el $RANDOM
done` >> full.params

if [ `info LIB_DIR` == "" ]; then
    echo LIB_DIR $OJASPER_ART_DIR/lib/ >> full.params
fi

echo Processing template .pov files
for el in `ls $AT_DIR/*.pov $AT_DIR/*.inc`; do
    pov=`basename $el`
    cp $el $pov
    replace `cat full.params | grep -v 'w ' |grep -v 'h '` -- $pov
done
